var R = Object.defineProperty;
var g = (e, t, r) => t in e ? R(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r;
var c = (e, t, r) => g(e, typeof t != "symbol" ? t + "" : t, r);
var T = /* @__PURE__ */ ((e) => (e[e.TIMEOUT = 1] = "TIMEOUT", e[e.MAX_RETRY_FAILED = 2] = "MAX_RETRY_FAILED", e[e.ABORT = 3] = "ABORT", e))(T || {}), o = /* @__PURE__ */ ((e) => (e[e.PENDING = 0] = "PENDING", e[e.FULFILLED = 1] = "FULFILLED", e[e.REJECTED = 2] = "REJECTED", e))(o || {});
const D = {
  [T.TIMEOUT]: "超时",
  [T.ABORT]: "中止"
};
class _ extends Error {
  constructor(t, r = D[t]) {
    super(r), this.code = t;
  }
}
let N = 0;
const A = (e, t) => (r, i) => {
  t.resolveWrap = (s) => {
    if (t.state !== o.PENDING) {
      console.log(`当前状态已经变为${t.state}, 忽略resolve`);
      return;
    }
    t.endTime = Date.now(), console.log(
      `${t.index} 调用成功${t.num++}次`,
      s,
      `耗时${t.endTime - t.startTime}ms`
    ), t.state = o.FULFILLED, t.clearTimeoutTimer(), r(s);
  }, t.rejectWrap = (s) => {
    if (t.state !== o.PENDING) {
      console.log(`当前状态已经变为${t.state}, 忽略reject`);
      return;
    }
    t.endTime = Date.now(), console.log(
      `${t.index} 调用失败${t.num++}次`,
      s,
      `耗时${t.endTime - t.startTime}ms`
    ), t.state = o.REJECTED, t.clearTimeoutTimer(), i(s);
  }, e(t.resolveWrap, t.rejectWrap);
}, x = (e) => {
  const t = {
    timeoutTimer: void 0,
    clearTimeoutTimer() {
      this.timeoutTimer && (clearTimeout(this.timeoutTimer), this.timeoutTimer = void 0);
    },
    startTime: Date.now(),
    state: o.PENDING,
    num: 0,
    index: N++
  }, r = A(e, t);
  return t.promise = new Promise(r), t.promise.catch((i) => {
    var s;
    return t.state === o.PENDING && (console.log("promise 内部出现pending状态错误", i), (s = t.rejectWrap) == null || s.call(t, i)), i;
  }), {
    baseInfo: t
  };
}, d = (e) => {
  let t;
  return {
    applyPromise: () => (t || (t = e(), t.catch(() => {
      t = void 0, console.log("Promise sharing: promise出错，已重置");
    })), t)
  };
};
class w extends _ {
  constructor(t) {
    const r = t.length;
    super(
      T.MAX_RETRY_FAILED,
      `执行${r}次，最终仍失败`
    ), this.errorList = t;
  }
}
const L = (e, {
  maxRetry: t,
  getDelay: r = () => 0
}) => {
  let i = 0;
  t < 0 && console.error("最大重试次数不能小于0， 此处将使用默认值 0");
  const s = Math.max(t, 0), m = [];
  return new Promise((h, p) => {
    const l = () => {
      e().then(h).catch((E) => {
        if (m.push(E), i < s) {
          i++;
          const a = r(i);
          a > 0 ? setTimeout(l, a) : l();
        } else
          p(new w(m));
      });
    };
    l();
  });
}, n = class n {
  constructor(t) {
    c(this, "__RAW_CONTEXT__");
    /** 超时设置 */
    c(this, "timeout", (t) => {
      const { baseInfo: r } = this.__RAW_CONTEXT__;
      if (r.state !== o.PENDING)
        return console.warn("超时设置失败，promise状态不为pending"), this;
      r.clearTimeoutTimer();
      const i = Math.max(0, r.startTime + t - Date.now());
      return console.log(`超时设置${t}ms, 剩余${i}ms`), r.timeoutTimer = setTimeout(() => {
        console.log("走到超时时刻"), r.rejectWrap(new _(T.TIMEOUT));
      }, i), this;
    });
    this.__RAW_CONTEXT__ = x(t);
  }
  // 修正 then 方法
  then(t, r) {
    return new n((i, s) => {
      this.__RAW_CONTEXT__.baseInfo.promise.then(t, r).then(i, s);
    });
  }
  // 修正 catch 方法
  catch(t) {
    return this.then(void 0, t);
  }
  // 修正 finally 方法
  finally(t) {
    return new n((r, i) => {
      this.__RAW_CONTEXT__.baseInfo.promise.finally(t).then(r, i);
    });
  }
  get [Symbol.toStringTag]() {
    return this.__RAW_CONTEXT__.baseInfo.promise[Symbol.toStringTag];
  }
};
/** promise共享 */
c(n, "useSharing", d), /** promise重试 */
c(n, "retry", L);
let u = n;
export {
  u as XPromise,
  _ as XPromiseError,
  T as XPromiseErrorCodeEnum
};
